<script lang="ts">
  import type { PageData } from "./$types";
  import { TeamScorecardStore, type TeamScorecard$result } from "$houdini";
  import User from "$lib/components/ui-elements/User.svelte";
  import { hasApiRole } from "$lib/components/layout/data/nav-tabs";
  import { authTokenParsed } from "$stores/authStore";
  import PageHeader from "$lib/components/layout/PageHeader.svelte";
  import Scorecard from "$lib/components/pages/results/2025/Scorecard.svelte";
  import TeamFeedback from "$lib/components/pages/results/TeamFeedback.svelte";

  export let data: PageData;
  let role: string | undefined;
  $: teamId = data.params.teamId;
  $: if ($authTokenParsed) role = hasApiRole($authTokenParsed, "staff") ? "staff" : "participant";
  const teamScorecard = new TeamScorecardStore();

  // todo count of flag submissions?
  async function getTeamScorecard() {
    const result = await teamScorecard.fetch({
      variables: { teamId, authenticated: !!$authTokenParsed },
      metadata: { role }
    });
    console.log(result);
    if (result.errors) throw result.errors;
    if (!result.data) throw new Error("No data found");
    return result.data;
  }
</script>

<PageHeader title="Team Results" />

<section class="p-4 md:p-20">
  {#if teamId}
    {#await getTeamScorecard()}
      loading
    {:then data}
      {#each data.events as event}
        <Scorecard team={event.teams[0].team} {event} {role}></Scorecard>
        <!-- this loop just gets access to the current team; there will only be 1 -->
        {#each event.teams.map(t => t.team) as team}
          <!-- Team Feedback -->
          {#if $authTokenParsed}
            {#if team.feedbacks?.length}
              <TeamFeedback teamFeedback={team.feedbacks}></TeamFeedback>
            {/if}

            <!-- Participation Awards -->
            <div class="text-4xl md:text-5xl font-extrabold font-comfortaa pt-10">Thanks to everyone who participated!
            </div>
            <div class="flex flex-col-reverse md:flex-row py-10 mx-auto" style="max-width: 900px">
              <img class="mx-auto p-4 sm:w-1/2" alt="2025 Participant Badge"
                   src="https://files.ncaecybergames.org/badges/participation_2025_badge.svg" />
              <div class="flex flex-grow flex-col">
                {#each team.members as member}
                  <div class="mx-auto py-1 text-xl flex-grow">
                    <User hideDiscord hideEmail hideStats user={member}></User>
                  </div>
                {/each}
              </div>
            </div>
          {/if}
        {/each}
      {/each}
    {:catch e}
      An error occurred
      <pre>{JSON.stringify(e, null, 2)}</pre>
    {/await}
  {/if}
</section>

